#!/usr/bin/python

def err_to_float(err):
    return 0 if err == '-' else float(err[:-1])

def read_results(fd, cutoff, rows):
    lines = [ x.strip() for x in fd.readlines() if x.strip() != '' ]
    for i in range(0, len(lines), 16):
        name = lines[i]
        num_mcvs = [ x.strip() for x in lines[i+9].split('|') ][1:]
        avg_mcv_err = [ x.strip() for x in lines[i+10].split('|') ][1:]
        max_mcv_err = [ x.strip() for x in lines[i+11].split('|') ][1:]
        avg_non_mcv_err = [ x.strip() for x in lines[i+12].split('|') ][1:]
        max_non_mcv_err = [ x.strip() for x in lines[i+13].split('|') ][1:]
        avg_err = [ x.strip() for x in lines[i+14].split('|') ][1:]
        max_err = [ x.strip() for x in lines[i+15].split('|') ][1:]

        for (j, mcv_cutoff, tgt) in [ (0, -cutoff, 100),
                                      (1, cutoff, 100),
                                      (2, -cutoff, 1000),
                                      (3, cutoff, 1000) ]:
            rows.append([ name, mcv_cutoff, tgt,
                          int(num_mcvs[j]),
                          err_to_float(avg_mcv_err[j]),
                          err_to_float(max_mcv_err[j]),
                          err_to_float(avg_non_mcv_err[j]),
                          err_to_float(max_non_mcv_err[j]),
                          err_to_float(avg_err[j]),
                          err_to_float(max_err[j]) ])

rows = []
for cutoff in [ 10, 15, 20, 25, 30, 35, 40, 45, 50 ]:
    with open('mcv-tests-%dpc.out' % cutoff, 'r') as fd:
        read_results(fd, cutoff, rows)

print '"test_name","mcv_cutoff","stats_tgt","num_mcvs",'+\
      '"avg_mcv_err","max_mcv_err","avg_non_mcv_err",'+\
      '"max_non_mcv_err","avg_err","max_err"'

for row in rows:
    str = '"%s",%d,%d,%d,%f,%f,%f,%f,%f,%f' %\
              ( row[0], row[1], row[2], row[3], row[4],
                row[5], row[6], row[7], row[8], row[9] )
    print str
